#ifndef DUMPFILE_H
#define DUMPFILE_H

/* $Id: dumpfile.h,v 1.2 2005/11/09 19:48:31 tachino Exp $ */

struct _DumpDevice;

typedef struct _DumpFile {
	struct _DumpDevice	*device;
	char			*name;
	int			 fd;
	const char		*dir;
	off_t			 data_offset;
	off_t			 page_desc_offset;
} DumpFile;

DumpFile *open_dump_file(char *dir);
int rename_dump_file(DumpFile *);
int write_page_desc(DumpFile *, page_desc_t *);
int write_page_data(DumpFile *, const void *data, uint32_t size);
int write_blocks(DumpFile *, const void *data, uint32_t size);

static inline int dump_seek(DumpFile *dump_file, off_t off) {
	if (lseek(dump_file->fd, off, SEEK_SET) != off)
		return -1;

	return 0;
}

#endif
