/*
 *  elf.c
 *
 *  Copyright (C) 2001-2004  Red Hat, Inc
 *
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/* $Id: elf.c,v 1.5 2006/04/21 19:38:38 akira Exp $ */

#define _GNU_SOURCE
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>

#include "../diskdumpelf.h"
#include "../dumpdevice.h"

void *get_task_struct_note(DumpDevice *device, int *note_len)
{
	struct disk_dump_header *header = device->header;
	void **taskstruct;
	int len = sizeof(void *) * 2;

	if ((taskstruct = calloc(1, len)) == NULL) {
		perror(program_invocation_short_name);
		exit(EXIT_FAILURE);
	}

	/*
	 * fill NT_TASKSTRUCT note with the addresses of all task_structs
	 * XXX It may be helpfull to add current_cpu too.
	 */
	taskstruct[0] = header->tasks[header->current_cpu];
	taskstruct[1] = NULL;	/* dummy switch_stack */

	*note_len = len;
	return taskstruct;
}
